//******************************************************************************
//!
//! @file $Id: main.c 2100 2008-09-25 13:01:59Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief 啔 : ͖JԂɊÂ܂B
//!
//! @todo
//! @bug
//******************************************************************************

/* 쌠 (c) 2008, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ _______________________________________________________________

#include "config.h"

#include "mc_interface.h"
#include "mc_control.h"
#include "mc_drv.h"

#include "adc\adc_drv.h"

#include "ushell_task.h"

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________

/* オ\ */
//U8 __flash ramp_up_time_table[] = {27,25,22,19,17,14,12,9,7,4,2};
//U8 __flash ramp_up_duty_table[] = {129,130,131,132,133,134,135,136,137,138,139};
//U8 __flash ramp_up_time_table[] = {27,25,22,19,17,14,12,9,3,3,1};					/* mȂd@ */
//U8 __flash ramp_up_duty_table[] = {129,130,131,132,133,134,135,136,138,139,140};	/* mȂd@ */
/************************************************************************************************/
#ifdef MC310_MOTOR
#ifdef __GNUC__
U8
#elif __ICCAVR__
U8 __flash 
#endif
ramp_up_time_table[] = {26,23,20,17,14,11,8,5,3,2,2};					/* MC310d@ */
#ifdef __GNUC__
U8
#elif __ICCAVR__
U8 __flash 
#endif
ramp_up_duty_table[] = {122,124,126,129,131,133,135,137,140,143,145};	/* MC310d@ */
#endif
/************************************************************************************************/
#ifdef ELECTROCRAFT_MOTOR
#ifdef __GNUC__
U8
#elif __ICCAVR__
U8 __flash 
#endif
ramp_up_time_table[] = {53,53,53,21,10,5,4,3,3,3};						/* Electrocraftd@ */
#ifdef __GNUC__
U8
#elif __ICCAVR__
U8 __flash 
#endif
ramp_up_duty_table[] = {128,129,130,132,137,139,144,151,156,159};		/* Electrocraftd@ */
#endif
/************************************************************************************************/
#ifdef RC_MOTOR
// Ȃg̕\ɒ`ĂB
#ifdef __GNUC__
U8
#elif __ICCAVR__
U8 __flash 
#endif
ramp_up_time_table[] = {22,20,18,16,14,12,10,8,7,6,5,4,4,4,4,4};
//U8 __flash ramp_up_duty_table[] = {128,132,136,140,144,148,152,156,160,164,168,172,176,176,176,176};
#ifdef __GNUC__
U8
#elif __ICCAVR__
U8 __flash 
#endif
ramp_up_duty_table[] = {128,132,136,140,144,148,152,156,160,164,166,168,170,160,160,160};
#endif
/************************************************************************************************/

//_____ 錾 __________________________________________________________________
U16 g_regulation_period = 0;		//!< ̎`
U16 motor_speed = 0;				//!< gpґx
extern volatile Bool g_tick;		// mc_drv.cɂĐA̎掞ԂɎgp
extern Bool overcurrent;
extern U8 duty_cycle;				//!< vZPWMޭè قݒ肷Ұ
extern U8 duty_cycle_reference;		//! hgO̊

  U8 ru_step_length_cntr = 0;
  U8 new_position = MS_001;
  U8 ru_step_length = RAMP_UP_STEP_MAX;
  U8 ru_period_counter = 0;
  U8 ramp_up_index = 0;
  U8 motor_state = MS_STOP;

//! ̊֐͗グ̐VʒuvZ܂B
inline void compute_new_position(void)
{
  if (mci_get_motor_direction()==CCW)
  {
	switch(new_position)
	{
	  /* CCWグ */
	  case MS_001:
		new_position = MS_011;
		break;
	  case MS_101:
		new_position = MS_001;
		break;
	  case MS_100:
		new_position = MS_101;
		break;
	  case MS_110:
		new_position = MS_100;
		break;
	  case MS_010:
		new_position = MS_110;
		break;
	  case MS_011:
		new_position = MS_010;
		break;
	  default :
		new_position = MS_001;
		break;
	}
  }
  else
  {
	switch(new_position)
	{
	  /* CWグ */
	  case MS_001:
		new_position = MS_101;
		break;
	  case MS_101:
		new_position = MS_100;
		break;
	  case MS_100:
		new_position = MS_110;
		break;
	  case MS_110:
		new_position = MS_010;
		break;
	  case MS_010:
		new_position = MS_011;
		break;
	  case MS_011:
		new_position = MS_001;
		break;
	  default :
		new_position = MS_001;
		break;
	}
  }
}

//! {̓
//!
//! d@䉞p̂߂̖{̓_\n
//! 80msmc_regulation_loop()֐Jn܂B\n
//!
int main(void)
{
U8 temp;
  // d@
  mc_init();					// d@p̏Jn
  // UARTʂOߗp̒ʐMт
  ushell_task_init();
  mci_backward();
  mci_run();
  while(1)
  {
	// v0256~4s(=1.024ms)g_tick𐶐܂B
	// g_tick=1.024ms
	if (g_tick == TRUE)
	{
	  g_tick = FALSE;
	  // dlƉϒRl擾
	  mc_ADC_Scheduler();
	  switch(motor_state)
	  {
		case (MS_ALIGN):
		  ru_period_counter--;
		  if (ru_period_counter==0)
		  {
			Clear_PC7();
			motor_state=MS_RAMP_UP;
		  }
		  break;
		case (MS_RAMP_UP):
		  // RAMP_UP_PERIOD~g_tickɓ̎ŗグ𕪊
		  // \ްŊeɑ΂ru_step_length𐶐
		  ru_period_counter += 1;
		  if ( ru_period_counter >= RAMP_UP_PERIOD )
		  {
			ru_period_counter = 0;
			ru_step_length = ramp_up_time_table[ramp_up_index];
			mc_duty_cycle(ramp_up_duty_table[ramp_up_index]);
			duty_cycle = ramp_up_duty_table[ramp_up_index];
			duty_cycle_reference = duty_cycle;
			if (ramp_up_index < RAMP_UP_INDEX_MAX)
			{
			  ramp_up_index += 1;
			}
			else
			{
			  motor_state=MS_LAST_RAMP_UP;
			}
		  }
		  // eiK̒Ď
		  ru_step_length_cntr += 1;
		  if ( ru_step_length_cntr >= ru_step_length )
		  {
			ru_step_length_cntr = 0;
			compute_new_position();
			mc_switch_commutation((Motor_Position)new_position);
//			Toggle_PC7();							// PC7ɎM𐶐
		  }
		  break;
		case (MS_LAST_RAMP_UP):
		  // eiK̒Ď
		  ru_step_length_cntr += 1;
		  if ( ru_step_length_cntr >= ru_step_length )
		  {
			ru_step_length_cntr = 0;
			compute_new_position();
			mc_switch_commutation((Motor_Position)new_position);
			start_running_phase();
			motor_state=MS_RUNNING;
			Set_PC7();								// PC7ɎM𐶐
		  }
		  break;
		case (MS_RUNNING):
		  g_regulation_period += 1;
		  if ( g_regulation_period >= 40 )			// n~1ms=Te
		  {
			g_regulation_period = 0;
			if (ushell_active == FALSE)
			{
			  // ϒRlŎgpґx߂ݒ
			  temp = mc_get_potentiometer_value();
			  if (temp > (POT_REF_MIN))
			  {
				mci_set_ref_speed((U8)temp);
				mc_regulation_loop();				// JԂJn
				mc_duty_cycle(mc_get_duty_cycle());
			  }
			  else
			  {
				mci_set_ref_speed(POT_REF_MIN);
				mc_regulation_loop();				// JԂJn
				mc_duty_cycle(mc_get_duty_cycle());
			  }
			}
			else
			{
			  mc_regulation_loop();					// JԂJn
			  mc_duty_cycle(mc_get_duty_cycle());
			}
		  }
		  break;
		case (MS_STOP):
		  if (ushell_active == FALSE)
		  {
			temp = mc_get_potentiometer_value();
			if (temp > (POT_REF_MIN))
			{
			  mci_run();
			}
		  }
		  break;
		default :
		  motor_state=MS_STOP;
		  break;
	  }
	  ushell_task();
//	  mc_inrush_task();								// dǗ
	  duty_cycle_filter ();
	}
  }
}
